/*********************************************************
 *********************************************************/

import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

import netscape.security.PrivilegeManager;

/**
 * An interactive test of the Graphics.drawArc and Graphics.fillArc
 * routines. Can be run either as a standalone application by
 * typing "java ArcTest" or as an applet in the AppletViewer.
 */

public class ArcTest extends Applet {

    ArcControls controls;

    int	saved_start;
    int	saved_end;
    int	saved_filled;

    Panel	message = new Panel();
    Label	message1;
    Label	message2;
    Label	message3;
    Label	message4;

    boolean	hasPrivilege = false;

    public  static PrintStream ff1 = null;

    private static String out_file = null;

    public void init() {

	act_privilege();

	ff1.println("");
	ff1.flush();

	setLayout(new BorderLayout());
	ArcCanvas c = new ArcCanvas();

	// make panel for message
	String blank_string = "                                   ";

	message.setLayout(new GridLayout(4, 1));
	message1 = new Label(blank_string, Label.LEFT);
	message2 = new Label(blank_string, Label.LEFT);
	message3 = new Label(blank_string, Label.LEFT);
	message4 = new Label(blank_string, Label.LEFT);

	message.add(message1);
	message.add(message2);
	message.add(message3);
	message.add(message4);

	update_message();

	add("North", message);
	add("Center", c);
	add("South", controls = new ArcControls(c, this));

    }

    public void start() {
	System.out.println("in start!");
	act_privilege();
	controls.enable();
    }

    public void stop() {
	controls.disable();
	ff1.close();
    }

    public void destroy() {
	ff1.close();
    }

    public boolean handleEvent(Event e) {
	if (e.id == Event.WINDOW_DESTROY) {
	    System.exit(0);
	}
	return false;
    }

    public void act_privilege() {
	PrivilegeManager.enablePrivilege("UniversalFileWrite");

	out_file = "c:\\test";
	try {
	    FileOutputStream f_out = new FileOutputStream(out_file);
	    ff1 = new PrintStream(f_out);
	    ff1.println("writing!!!");
	}
	catch(IOException e) {
	    System.exit(1);
	}
    }

    public void update_message() {
	System.out.println("update the message!!");
    }
}

class ArcCanvas extends Canvas {
    int	startAngle = 0;
    int	endAngle = 45;
    boolean	filled = false;
    Font	font;

    public void paint(Graphics g) {
	Rectangle r = bounds();
	int hlines = r.height / 10;
	int vlines = r.width / 10;

	g.setColor(Color.pink);
	for (int i = 1; i <= hlines; i++) {
	    g.drawLine(0, i * 10, r.width, i * 10);
	}
	for (int i = 1; i <= vlines; i++) {
	    g.drawLine(i * 10, 0, i * 10, r.height);
	}

	g.setColor(Color.red);
	if (filled) {
	    g.fillArc(0, 0, r.width - 1, r.height - 1, startAngle, endAngle);
	}
	else {
	    g.drawArc(0, 0, r.width - 1, r.height - 1, startAngle, endAngle);
	}

	g.setColor(Color.black);
	g.setFont(font);
	g.drawLine(0, r.height / 2, r.width, r.height / 2);
	g.drawLine(r.width / 2, 0, r.width / 2, r.height);
	g.drawLine(0, 0, r.width, r.height);
	g.drawLine(r.width, 0, 0, r.height);
	int sx = 10;
	int sy = r.height - 28;
	g.drawString("S = " + startAngle, sx, sy); 
	g.drawString("E = " + endAngle, sx, sy + 14); 
    }

    public void redraw(boolean filled, int start, int end) {
	this.filled = filled;
	this.startAngle = start;
	this.endAngle = end;
	repaint();
    }
}

class ArcControls extends Panel {
    TextField s;
    TextField e;
    ArcCanvas canvas;
    ArcTest test;

    public ArcControls(ArcCanvas canvas, ArcTest test) {
	this.canvas = canvas;
	this.test = test;
	add(s = new TextField("0", 4));
	add(e = new TextField("45", 4));
	add(new Button("Fill"));
	add(new Button("Draw"));
    }

    public boolean action(Event ev, Object arg) {

	String send_data = null;
	int button_action;
	int int_start;
	int int_end;
	boolean filled;

	if (ev.target instanceof Button) {
	    String label = (String)arg;

	    filled = label.equals("Fill");
	    if (filled) {
		button_action = 1;
	    }
	    else {
		button_action = 0;
	    }

	    int_start = Integer.parseInt(s.getText().trim());
	    int_end   = Integer.parseInt(e.getText().trim());

	    test.saved_start	= int_start;
	    test.saved_end		= int_end;
	    test.saved_filled	= button_action;

	    // make one string data to be sent,
	    // convert to byte, and send it
	    send_data = button_action + " " + int_start + " " + int_end;

	    draw_canvas(filled, int_start, int_end);
	    test.update_message();
	    return true;
	}
	return false;
    }

    public void draw_canvas(boolean filled, int start, int end) {
	canvas.redraw(filled, start, end);
	test.ff1.println("Filled       : " + filled);
	test.ff1.println("Start Degree : " + start);
	test.ff1.println("Angle        : " + end);
	test.ff1.println("");
	test.ff1.flush();
    }
}

